

drop table class_students;
drop table class_instructors;
drop table classes;
drop table courses;
drop table db_users;
drop table users;
drop table addresses;
drop table v_states;
drop table v_countries;
drop table v_surtitles;

create table addresses (
 id 	varchar2(50) constraint nn_addressid NOT NULL,
 address varchar2(50),
 city	varchar2(30),
 state 	varchar2(2),
 zip	varchar2(11),
 country varchar2(40),
 phone	varchar2(15),
 phone_ext varchar2(6),
 alt_phone varchar2(15),
 fax	varchar2(15),
 email	varchar2(50),
 bldg_address varchar2(50),
 poc	varchar2(50),
 alt_poc varchar2(50)
);


create table users (
 oracle_uid varchar(30) constraint nn_uid NOT NULL
			constraint pk_uid primary key,
 institution varchar2(20),
 submitter varchar2(30),
 create_date date,
 modified_date date,
 modified_uid varchar2(30),
 valid_user varchar2(1),
 first_nam varchar2(35),
 last_nam varchar2(35),
 middle_nam varchar2(35),
 surtitle varchar2(7),
 approved_date date,
 expiration_date date,
 citizenship varchar2(30),
 company_nam varchar2(80),
 us_or_foreign varchar2(8),
 univ_nam varchar2(80),
 contractor varchar2(1),
 foreign_national varchar2(1),
 asylum_num varchar2(13),
 green_card_num varchar2(25),
 temp_res_num varchar2(25),
 perm_res_num varchar2(25),
 refugee_num varchar2(25),
 organization varchar2(25),
 passwd_received varchar2(1),
 purpose varchar2(2000),
 spons_agency_uid varchar2(30) constraint fk_spons
				references users(oracle_uid),
 position varchar2(60),
 poc_uid varchar2(30) constraint fk_pocid
				references users(oracle_uid),
 special_reqs varchar2(2000)
);


create table db_users (
db_id varchar2(30) constraint nn_dbid NOT NULL,
passwd varchar2(30),
role number(2)
);

create table courses (
 course_id number(10)  constraint nn_courseid NOT NULL
		       constraint pk_courseid primary key,
 course_num varchar2(10) constraint nn_cnum NOT NULL,
 title varchar2(200) constraint nn_title NOT NULL,
 overview varchar2(4000) constraint nn_ovweview NOT NULL,
 duration number(6) constraint nn_duration NOT NULL,
 agenda varchar2(4000),
 prerequisites varchar2(200)
);



create table classes (
 class_id number(10)  constraint nn_classid NOT NULL
		      constraint pk_classid primary key,
 course_id number(10) constraint nn_cid NOT NULL
		      constraint fk_cid 
				references courses(course_id),
 class_start_date date constraint nn_classdate NOT NULL,
 class_size number(10) constraint nn_classsize NOT NULL,
 location varchar2(50) constraint nn_location NOT NULL,
 city varchar2(30) constraint nn_city NOT NULL,
 state varchar2(2) constraint nn_state NOT NULL,
 building varchar2(30),
 room varchar2(20)
);


create table class_instructors (
 class_id number(10) constraint nn_idclass NOT NULL
	 	     constraint fk_idclass
			references classes(class_id),
 instructor_uid varchar2(30) constraint nn_insuid NOT NULL
			     constraint fk_insuid 
				references users(oracle_uid),
 constraint pk_idclass primary key (class_id,instructor_uid)
);


create table class_students (
 class_id number(10) constraint nn_stuclassid NOT NULL
		     constraint fk_stuclassid 
			references classes(class_id),
 student_uid varchar2(30) constraint nn_stuuid NOT NULL
 			  constraint fk_stuuid 
				references users(oracle_uid),
 register_date date constraint nn_regdate NOT NULL,
 confirm_indctr varchar2(1) constraint nn_confirm NOT NULL,
 constraint pk_stuclassid primary key (class_id,student_uid)
);


create table v_states (
 state varchar2(50) constraint nn_vstate NOT NULL,
 state_nam varchar2(50) constraint nn_statename NOT NULL
);


create table v_countries (
 country_abbr varchar2(2),
 country_nam varchar2(60) constraint nn_countryname NOT NULL
);

create table v_surtitles (
 surtitle varchar2(7) constraint nn_surtitle NOT NULL
); 

drop view user_info;
create view user_info as
	select * from users a, db_users b, addresses c
 	where a.oracle_uid = b.db_id and a.oracle_uid = c.id;

drop view class_schedule;
create view class_schedule as
	select a.agenda, a.duration, a.prerequisites,a.title,a.course_num,
		a.overview,
		b.class_id,b.class_start_date,b.location,
		b.city,b.state,b.building,b.room,b.course_id,b.class_size,
		c.instructor_uid,
		d.first_nam, d.last_nam
	from courses a, classes b, class_instructors c, users d
	where a.course_id = b.course_id
	and   b.class_id = c.class_id
	and   c.instructor_uid = d.oracle_uid;

drop view class_roster;
create view class_roster as
	select a.class_id, a.register_date, a.confirm_indctr,
		b.first_nam, b.last_nam, c.email, b.position
	from class_students a, users b, addresses c
	where a.student_uid = b.oracle_uid
	and b.oracle_uid = c.id;

drop view simple_class;
create view simple_class as
	select a.agenda, a.duration, a.prerequisites,a.title,a.course_num,
		a.overview,
		b.class_id,b.class_start_date,b.location,
		b.city,b.state,b.building,b.room,b.course_id,b.class_size
	from courses a, classes b
	where a.course_id = b.course_id;