/*********************************************************************** 
 * Program: Config.java
 * Purpose: To edit the file configure.txt
 **********************************************************************/
package installation;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class ConfigEdit extends Frame implements ActionListener {

  public static final int TEXTSIZE=40;
  public int nitems=0;
  String[][] stringArray=new String[2][20];

  File input,output;
  FileWriter outFile; 
  BufferedReader inBuff;
  BufferedWriter outBuff;
  ObjectOutputStream outStream;
  PrintWriter outPrint;
  String FileName="configure.txt";

  Panel p1,p2;
  TextField[] text;
  Label[] l;
  Button b1,b2;
   
  // The constructor calls methods that do all of the real work.
  public ConfigEdit() {
    //Read in the configuration file
    try{
      input=new File(FileName);
            
      inBuff=
	new BufferedReader(new 
			   InputStreamReader(new
					     FileInputStream(input)));

    }
    catch (IOException e) {System.out.println("Couldn't open "+FileName) ;}
    processText();    
    windowSetup();  
  }
  
  public void windowSetup() { 
    
    p1=new Panel();
    p2=new Panel();
    setLayout(new BorderLayout());
    add("Center",p1);
    add("South",p2);

    // Add some things to the top panel.
    text=new TextField[8];
    l=new Label[8];

    for(int i=0;i<nitems;i++) {
      l[i]=new Label(stringArray[0][i],Label.LEFT);    
      text[i]=new TextField(stringArray[1][i],40);
      p1.add(l[i]);
      p1.add(text[i]);
      //      text[i].addActionListener(this);
    }    
    // Add some things to the bottom panel.
    b1=new Button("Save Changes");
    b2=new Button("Close Window");
    p2.add(b1);
    p2.add(b2);
    b1.addActionListener(this);
    b2.addActionListener(this);
  }
  
  public void processText() {
    String c1="initial junk",c2;
    try {
      while(c1!=null) {
	c1=inBuff.readLine();
	c2=inBuff.readLine();
	if(c1!=null) stringArray[0][nitems]=c1;
	if(c2!=null) stringArray[1][nitems]=c2;
	nitems=nitems+1;
      }
      nitems=nitems-1;  //Don't include the final "nulls"
    } catch(EOFException eof) {;} catch (IOException e) {;} 
  }
  
  public void actionPerformed(ActionEvent event) {
    Object source=event.getSource();
    if(source==b1){ 
      printOutput();
    }
    else if(source==b2){
      this.dispose();
    }
  }
  
  public void printOutput() {
    //Note: By opening configure.txt inside this scope, the original file
    //is not overwritten.  If I had opened the file for output in the 
    //constructor, I would have erased its contents.

    try{
      outPrint=new PrintWriter(new FileOutputStream(FileName));
      for(int i=0;i<nitems;i++) {
	outPrint.println(l[i].getText());
	outPrint.println(text[i].getText());
	outPrint.flush();
      }
    }
    catch (IOException e) {;} 
  }
  

  protected void finalize() throws Throwable {
    inBuff.close();
    outBuff.close();
    super.finalize();
  }

  public static void main(String[] args) throws IOException {
    
    Frame f=new ConfigEdit();
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0);}
    });
    f.setSize(400,600);
    f.show();
    //    f.pack();
    //f.setVisible(true);
    
  }
  
}		

