/***********************************************************************
 * Program: Entry.java
 * Purpose: Forces user to log on with the proper admin name and 
 * password before proceeding to the setup pages.  Uses a simple event
 * model with Install.java that can perhaps be improved upon.
 **********************************************************************/
package installation;
import java.awt.*;
import java.awt.event.*;

public class Entry extends Frame implements ActionListener{
  
  private static final String NAME="adm0";
  private static final String PASS="ok";
  
  private MyDialog dialog=null;
  
  Panel p0,p1,p2;
  Button b1,b2;
  TextField t1,t2;
  Label l1,l2;
  Install listener;

  char c='*';

  //Use this if called by an instance of the class Install.
  public Entry(Install parent) {
    init();
    listener=parent;
  }

  //Use this for a standalone.
  public Entry() {
    init();
    listener=null;
  }
   
  public void init(){
    p0=new Panel();
    p1=new Panel();
    p2=new Panel();
    setLayout(new GridLayout(3,1));

    p0.add(new Label("Please Log In:"));
    add(p0);

    //Add textfields to the text panel.
    t1=new TextField(null,20);
    t2=new TextField(null,20);
    t2.setEchoChar(c);

    p1.add(new Label("Name:"));
    p1.add(t1);
    p1.add(new Label("Pass:"));
    p1.add(t2);
    add(p1);

    //Add buttons to the button panel.
    b1=new Button("Submit");
    b2=new Button("Cancel");
    b1.addActionListener(this);
    b2.addActionListener(this);
    p2.add(b1);
    p2.add(b2);
    add(p2);
  }
  
  public void actionPerformed(ActionEvent event) {
    Object source=event.getSource();
    if(source==b1) {
      if(listener!=null){
	verifyLogin();
      }
      else{
	verifyLogin();
      }
    }
    else if(source==b2) {
      //Use this if created by a parent.
      if(listener!=null) {
	listener.notify(this);
	closeWindow();
	System.exit(1);
      }
      // Use this for standalone
      else {
	closeWindow();
	System.exit(1);
      }
    }
  }
  
  private void verifyLogin() {
    //Note that strings cannot be compared with == or !=
    if((t1.getText().equals(NAME))
       &&(t2.getText().equals(PASS))) {
      	listener.notify(this);
	closeWindow();
    }
    else {
      if(dialog==null) {
	dialog=new MyDialog(this,"Incorrect Login");
      }
      dialog.show();
    }
  }

  public void closeWindow() {
    this.dispose();
    //    System.exit(0);
  }

  public static void main(String[] args) {
    //Note:  the pack() method sets the window size automatically.
    Entry f=new Entry();
    f.addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e) {System.exit(0);}});
    f.setTitle("Entry Page");
    f.pack();
    f.setVisible(true);

    //    f.setSize(800,800);
    //f.show();
  }

}







